# minimorph

Super-light minimal, fast and memory effecient complex morph tool<br/>
[![NPM](https://nodei.co/npm/minimorph.png?downloads=true&stars=true)](https://nodei.co/npm/minimorph/)
<br/>
<img src="http://img.badgesize.io/http://cdn.jsdelivr.net/npm/minimorph@latest"/>  <img src="http://img.badgesize.io/http://cdn.jsdelivr.net/npm/minimorph@latest?compression=gzip"/> 
[![Greenkeeper badge](https://badges.greenkeeper.io/dalisoft/minimorph.svg)](https://greenkeeper.io/)  [![Scrutinizer](https://img.shields.io/scrutinizer/g/dalisoft/minimorph.svg)]()  [![Scrutinizer Coverage](https://img.shields.io/scrutinizer/coverage/g/dalisoft/minimorph.svg)]()  [![NPM Version][npm-image]][npm-url]  [![Travis tests][travis-image]][travis-url]<br/>
[![NPM Downloads][downloads-image]][downloads-url]  [![Github Releases](https://img.shields.io/github/downloads/dalisoft/minimorph/latest/total.svg)]()    [![jsdelivr](https://img.shields.io/badge/cdn-jsdelivr-brightgreen.svg)](https://cdn.jsdelivr.net/npm/minimorph)  [![unpkg](https://img.shields.io/badge/cdn-unpkg-brightgreen.svg)](https://unpkg.com/minimorph)  [![npmcdn](https://img.shields.io/badge/cdn-npmcdn-brightgreen.svg)](https://npmcdn.com/minimorph)<br/>
[![Flattr this][flattr-image]][flattr-url]  [![license](https://img.shields.io/github/license/dalisoft/minimorph.svg)]()

## Demo
* [Play with Codepen](https://codepen.io/dalisoft/pen/OgaPqw)

## Alternatives
There a lot alternatives, maybe they better than this app, maybe not, it's your choice. I am just list

* [GSAP MorphSVG](https://greensock.com/morphSVG) - Paid app
* [ShapeShifter](https://shapeshifter.design/) - Free + GUI + SVG Shape optimize/preparer (can be used for it)
* [Wilderness](https://github.com/colinmeinke/wilderness) - Free + Well API + CDN
* [svg-tween](https://github.com/colinmeinke/svg-tween) - Free + Simple & Minimal + CDN
* [Flubber](https://github.com/veltman/flubber) - Free
* [SVGMorpheus](https://alexk111.github.io/SVG-Morpheus) - Free + For SVG Group only
* [SnapSVG](http://snapsvg.io/) - Free - Popular well-known amazing tool, not only for morph, for all of SVG things
* [RaphaelJS](http://dmitrybaranovskiy.github.io/raphael) - Free - Same as SnapSVG, but for backward-compatible apps
* [BonsaiJS](http://bonsaijs.org/) - Free - Not tested or used (so review is too good, good docs)
* [KuteJS](http://thednp.github.io/kute.js/svg.html) - Free - CDN + Well API

## Installation

Download the [library](https://cdn.jsdelivr.net/npm/minimorph) and include it in your code:

```html
<script src="js/morph.js"></script>
```

### CDN-Hosted version

* See [cdnjs-hosted version](cdnjs.com/libraries/minimorph) for get which result you want
* NOTE: `@latest` suffix sometimes saves life by loading latest, because sometimes CDN services will not load the latest

```html
<script src="https://cdn.jsdelivr.net/npm/minimorph"></script>
<!-- or may you want -->
<script src="https://unpkg.com/minimorph"></script>
<!-- or like this -->
<script src="https://npmcdn.com/minimorph"></script>
```


### More advanced users might want to...

#### Using `grunt`

PR are welcome...

#### Using `gulp`

PR are welcome...

#### Using `node`

```javascript
var morph = require('minimorph');
```

#### Using `import`

```javascript
import morph from 'minimorph';
```

#### Using [getlibs](https://github.com/activewidgets/getlibs)

```html
<script src="https://unpkg.com/getlibs"></script>
<script type="x-module">
import morph from 'minimorph';
</script>
```

#### Using `npm`, `yarn` or `bower`

```bash
$ yarn add minimorph
# or
$ npm install minimorph
```

### Basic usage

```javascript
morph.easing.moca = k => 0.5 + Math.pow(k * k / k * k, 4) / k * k - 0.5

let m = morph(
	{ type: 'path',
	  d: 'M480,50L423.8,182.6L280,194.8L389.2,289.4L356.4,430L480,355.4L480,355.4L603.6,430L570.8,289.4L680,194.8L536.2,182.6Z'
	},
	{ type: 'path',
      d: 'M638.9,259.3v-23.8H380.4c-0.7-103.8-37.3-200.6-37.3-200.6s-8.5,0-22.1,0C369.7,223,341.4,465,341.4,465h22.1c0,0,11.4-89.5,15.8-191h210.2l11.9,191h22.1c0,0-5.3-96.6-0.6-205.7H638.9z'
	}, true)

let mw = morph.middleware([0, 0, 0], [0, 204, 255], 'color');

let p = document.querySelector('#path');
    p.setAttribute('d', m(0))


morph.frame({frame:
function anim(t) {
t = morph.easing.moca(t);
p.setAttribute('d', m(t));
p.setAttribute('fill', mw(t));

}, duration:2000, startTime:1000});
```


### Tests
Currently only linting tests has and can be running with
```bash
npm test
```

[npm-image]: https://img.shields.io/npm/v/minimorph.svg
[npm-url]: https://npmjs.org/package/minimorph
[downloads-image]: https://img.shields.io/npm/dm/minimorph.svg
[downloads-url]: https://npmjs.org/package/minimorph
[travis-image]: https://travis-ci.org/dalisoft/minimorph.svg?branch=master
[travis-url]: https://travis-ci.org/dalisoft/minimorph
[flattr-image]: https://api.flattr.com/button/flattr-badge-large.png
[flattr-url]: https://flattr.com/submit/auto?fid=kxw7jx&url=https%3A%2F%2Fgithub.com%2Fdalisoft%2Fminimorph
[cdnjs-image]: https://img.shields.io/cdnjs/v/minimorph.svg
[cdnjs-url]: https://cdnjs.com/libraries/minimorph
